Subject: Re: bug#79323: 30.2; Control-X-prefix not remapable

From: Stéphane Marks <[email-masked]>
Date: Thu, 28 Aug 2025 13:58:33 -0400

On Thu, Aug 28, 2025 at 1:56 PM Scott Bell via Bug reports for GNU Emacs,
the Swiss army knife of text editors <[email-masked]> wrote:

> > As an update, I am attaching my current .emacs.  Interestingly, it
> > does not set C-x for the entire session, but if I eval-region on the
> > overriding-local-map chunk, then it takes. Is the overriding-local-map
> > so local that it won’t work in .emacs?
>
> I was able to reproduce the issue as described on macOS with the .emacs
> provided, and reduced it to the minimum as follows:
>
> (define-key global-map [(control ?\])] 'Control-X-prefix)
> (make-local-variable 'overriding-local-map)
> (setq overriding-local-map (copy-keymap global-map))
> (define-key overriding-local-map [(control ?\])] 'Control-X-prefix)
> (global-set-key [(control x)] 'next-line)
> (define-key global-map [(control x)] 'next-line)
> (define-key overriding-local-map [(control x)] 'next-line)
>
> (custom-set-variables
>  '(global-tab-line-mode t))
>
> The culprit here is global-tab-line-mode.
>
> Commit 230eecf12a introduces C-x prefixed bindings for tab switching,
> which are present in 30.2 but not 29.4.
>

If I were a `tab-line` user, I suppose we would have done the same there as
we did in `tab-bar.  See master `tab-bar-define-keys` which I bind to nil
as I manage my own bindings.